module MineSkin
  # Composition tools
  module Compositor
    def resize(img, old_unit)
      img.sample(@unit.to_f / old_unit.to_f)
    end

    # rubocop:disable MethodLength
    def composite_texture!(tex, x, y, old_unit, op: Magick::SrcOverCompositeOp)
      @image.composite!(
        resize(tex.texture, old_unit),
        x * @unit,
        y * @unit,
        op
      )
      @image.composite!(
        resize(tex.overlay, old_unit),
        x * @unit,
        y * @unit,
        op
      ) if tex.overlay
    end
    # rubocop:enable MethodLength
  end
end
