require 'rmagick'

module MineSkin
  module Preview
    class Cape2D
      include Unit
      include Compositor

      def initialize(cape_data)
        @cape_data = cape_data
      end

      def render(width, background: 'white')
        @unit = image_unit size: width, count: 40
        @image = Magick::Image.new(width, 65 * width / 100) do
          self.background_color = background
        end
        render_cape!
        @image
      end

      protected

      def render_cape!
        composite_texture! @cape_data.cape.front, 5, 5, @cape_data.unit
        composite_texture! @cape_data.cape.back, 25, 5, @cape_data.unit
      end

    end
  end
end
